<script setup>
import BeatLoader from "vue-spinner/src/BeatLoader.vue";
import { SEARCH_PER_PAGE, MAX_GITHUB_RESULTS } from "@/constants/search";

const props = defineProps(["currentPage", "total", "loading"]);
const emit = defineEmits(["onClick"]);

const maxPage = MAX_GITHUB_RESULTS / SEARCH_PER_PAGE;
const enabled = props.currentPage <= maxPage;
const reachTotal = props.currentPage * SEARCH_PER_PAGE >= props.total;
</script>

<template>
  <div class="pagination">
    <button
      v-if="enabled && !loading"
      :disabled="reachTotal"
      @click="emit('onClick', props.currentPage + 1)"
    >
      Carregar mais
    </button>

    <BeatLoader :loading="loading" />
  </div>
</template>

<style lang="scss" scoped>
.pagination {
  display: flex;
  place-content: center;

  button {
    border: none;
    background: none;
    font-size: 16px;
    cursor: pointer;

    &:hover {
      text-decoration: underline;
    }

    &:disabled {
      cursor: default;
      text-decoration: none;
    }
  }
}
</style>
